# (C) 2001-2015 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License Subscription 
# Agreement, Altera MegaCore Function License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


set script_dir [file dirname [info script]]

load_package sdc_ext

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_index_in_collection { col j } {
   set i 0
   foreach_in_collection path $col {
      if {$i == $j} {
         return $path
      }
      set i [expr $i + 1]
   }
   return ""
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_clock_to_pin_name_mapping {} {
   set result [list]
   set clocks_collection [get_clocks]
   foreach_in_collection clock $clocks_collection { 
      set clock_name [get_clock_info -name $clock] 
      set clock_target [get_clock_info -targets $clock]
      set first_index [ed_synth_altera_emif_arch_nf_150_3u2ihai_index_in_collection $clock_target 0]
      set catch_exception_net [catch {get_net_info -name $first_index} pin_name_net]
      if {$catch_exception_net == 0} {
         lappend result [list $clock_name $pin_name_net]
      } else {
         set catch_exception_port [catch {get_port_info -name $first_index} pin_name_port]
         if {$catch_exception_port == 0} {
            lappend result [list $clock_name $pin_name_port]
         } else {
            set catch_exception_reg [catch {get_register_info -name $first_index} pin_name_reg]
            if {$catch_exception_reg == 0} {
               lappend result [list $clock_name $pin_name_reg]
            } else {
               set catch_exception_pin [catch {get_pin_info -name $first_index} pin_name_pin]
               if {$catch_exception_pin == 0} {
                  lappend result [list $clock_name $pin_name_pin]
               } 
            }
         }
      }
   }
   return $result
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_clock_name_from_pin_name { pin_name } {
   set table [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_clock_to_pin_name_mapping]
   foreach entry $table {
      if {[string compare [lindex [lindex [split $entry] 1] 0] $pin_name] == 0} {
         return [lindex $entry 0]
      }
   }
   return ""
}



proc ed_synth_altera_emif_arch_nf_150_3u2ihai_find_all_keepers { mystring } {
   set allkeepers [get_keepers $mystring ]

   foreach_in_collection keeper $allkeepers {
      set keepername [ get_node_info -name $keeper ]

      puts "$keepername"
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_round_3dp { x } {
   return [expr { round($x * 1000) / 1000.0  } ]
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_current_timequest_report_folder {} {

   set catch_exception [catch {get_current_timequest_report_folder} error_message]
   if {[regexp ERROR $error_message] == 1} {
      return "ReportDDR"
   } else {
      return [get_current_timequest_report_folder]
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_timequest_name {hier_name} {
   set sta_name ""
   for {set inst_start [string first ":" $hier_name]} {$inst_start != -1} {} {
      incr inst_start
      set inst_end [string first "|" $hier_name $inst_start]
      if {$inst_end == -1} {
         append sta_name [string range $hier_name $inst_start end]
         set inst_start -1
      } else {
         append sta_name [string range $hier_name $inst_start $inst_end]
         set inst_start [string first ":" $hier_name $inst_end]
      }
   }
   return $sta_name
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_are_entity_names_on { } {
   set entity_names_on 1


   return [set_project_mode -is_show_entity]   
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_core_instance_list {corename} {
   global ::io_only_analysis

   if {$::io_only_analysis == 1}  {
      set instance_list [list $corename]

   } else {
      set full_instance_list [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_core_full_instance_list $corename]
      set instance_list [list]

      foreach inst $full_instance_list {
         set sta_name [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_timequest_name $inst]
         if {[lsearch $instance_list [escape_brackets $sta_name]] == -1} {
            lappend instance_list $sta_name
         }
      }

   }
   return $instance_list
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_or_add_generated_clock {args} {
   array set opts { /
      -name "" /
      -target "" /
      -source "" /
      -multiply_by 1 /
      -divide_by 1 /
      -phase 0 }

   array set opts $args

   set multiply_by [expr int($opts(-multiply_by))]
   if {[expr $multiply_by - $opts(-multiply_by)] != 0.0} {
      post_message -type error "Specify an integer ranging from 0 to 99999999 for the option -multiply_by"
      return ""
   }

   set clock_name [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_clock_name_from_pin_name $opts(-target)]

   if {[string compare -nocase $clock_name ""] == 0} {
      set nets [get_nets $opts(-target) -nowarn]
      if {[get_collection_size $nets] > 0} {
         set pin_name [get_pin_info -name [get_net_info -pin $nets]]
         set clock_name [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_clock_name_from_pin_name $pin_name]

         if {[string compare -nocase $clock_name ""] != 0} {
            if {[regexp -nocase "lvds_clk" $pin_name] || [regexp -nocase "loaden" $pin_name] } {
               remove_clock $clock_name
               set clock_name ""
            }
          }
       }
   }

   if {[string compare -nocase $clock_name ""] == 0} {
      set clock_name $opts(-name)

      create_generated_clock \
         -name $clock_name \
         -source $opts(-source) \
         -multiply_by $multiply_by \
         -divide_by $opts(-divide_by) \
         -phase $opts(-phase) \
         $opts(-target)
   }

   return $clock_name
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_core_full_instance_list {corename} {
   set allkeepers [get_keepers * ]

   set_project_mode -always_show_entity_name on

   set instance_list [list]

   set inst_regexp {(^.*}
   append inst_regexp {:[A-Za-z0-9\.\\_\[\]\-\$():]+)\|}
   append inst_regexp "${corename}"
   append inst_regexp {:arch|}
   append inst_regexp core_*
   append inst_regexp {:arch_inst}   

   foreach_in_collection keeper $allkeepers {
      set name [ get_node_info -name $keeper ]

      if {[regexp -- $inst_regexp $name -> hier_name] == 1} {
         if {[lsearch $instance_list [escape_brackets $hier_name]] == -1} {
            lappend instance_list $hier_name
         }
      }
   }

   set_project_mode -always_show_entity_name qsf

   if {[ llength $instance_list ] == 0} {
      post_message -type error "The auto-constraining script was not able to detect any instance for core < $corename >"
      post_message -type error "Make sure the core < $corename > is instantiated within another component (wrapper)"
      post_message -type error "and it's not the top-level for your project"
   }

   return $instance_list
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_fanin_up_to_depth { node_id match_command edge_type results_array_name depth} {
   upvar 1 $results_array_name results

   if {$depth < 0} {
      error "Internal error: Bad timing netlist search depth"
   }
   set fanin_edges [get_node_info -${edge_type}_edges $node_id]
   set number_of_fanin_edges [llength $fanin_edges]
   for {set i 0} {$i != $number_of_fanin_edges} {incr i} {
      set fanin_edge [lindex $fanin_edges $i]
      set fanin_id [get_edge_info -src $fanin_edge]
      if {$match_command == "" || [eval $match_command $fanin_id] != 0} {
         set results($fanin_id) 1
      } elseif {$depth == 0} {
      } else {
         ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_fanin_up_to_depth $fanin_id $match_command $edge_type results [expr {$depth - 1}]
      }
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_is_node_type_pin { node_id } {
   set node_type [get_node_info -type $node_id]
   if {$node_type == "port"} {
      set result 1
   } else {
      set result 0
   }
   return $result
}




proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_pll_clock_name { clock_id } {
   set clock_name [get_node_info -name $clock_id]

   return $clock_name
}




proc post_sdc_message {msg_type msg} {
   global ::io_only_analysis

   if {($::io_only_analysis == 1) || $::TimeQuestInfo(nameofexecutable) != "quartus_fit"} {
      post_message -type $msg_type $msg
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_names_in_collection { col } {
   set res [list]
   foreach_in_collection node $col {
      lappend res [ get_node_info -name $node ]
   }
   return $res
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_format_3dp { x } {
   return [format %.3f $x]
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_colours { x y } {

   set fcolour [list "black"]
   if {$x < 0} {
      lappend fcolour "red"
   } else {
      lappend fcolour "blue"
   }
   if {$y < 0} {
      lappend fcolour "red"
   } else {
      lappend fcolour "blue"
   }

   return $fcolour
}

proc min { a b } {
   if { $a == "" } { 
      return $b
   } elseif { $a < $b } {
      return $a
   } else {
      return $b
   }
}

proc max { a b } {
   if { $a == "" } { 
      return $b
   } elseif { $a > $b } {
      return $a
   } else {
      return $b
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_max_in_collection { col attribute } {
   set i 0
   set max 0
   foreach_in_collection path $col {
      if {$i == 0} {
         set max [get_path_info $path -${attribute}]
      } else {
         set temp [get_path_info $path -${attribute}]
         if {$temp > $max} {
            set max $temp
         } 
      }
      set i [expr $i + 1]
   }
   return $max
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection { col attribute } {
   set i 0
   set min 0
   foreach_in_collection path $col {
      if {$i == 0} {
         set min [get_path_info $path -${attribute}]
      } else {
         set temp [get_path_info $path -${attribute}]
         if {$temp < $min} {
            set min $temp
         } 
      }
      set i [expr $i + 1]
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection_to_clock { col attribute clock } {
   set i 0
   set min ERROR
   foreach_in_collection path $col {
      if {[get_clock_info -name [get_path_info $path -to_clock]] == $clock} {
         if {$i == 0} {
            set min [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp < $min} {
               set min $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection_from_clock { col attribute clock } {
   set i 0
   set min ERROR
   foreach_in_collection path $col {
      if {[get_clock_info -name [get_path_info $path -from_clock]] == $clock} {
         if {$i == 0} {
            set min [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp < $min} {
               set min $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection_to_name { col attribute name } {
   set i 0
   set min 0
   foreach_in_collection path $col {
      if {[get_node_info -name [get_path_info $path -to]] == $name} {
         if {$i == 0} {
            set min [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp < $min} {
               set min $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection_from_name { col attribute name } {
   set i 0
   set min 0
   foreach_in_collection path $col {
      if {[get_node_info -name [get_path_info $path -from]] == $name} {
         if {$i == 0} {
            set min [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp < $min} {
               set min $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_max_in_collection_to_name { col attribute name } {
   set i 0
   set max 0
   foreach_in_collection path $col {
      if {[get_node_info -name [get_path_info $path -to]] == $name} {
         if {$i == 0} {
            set max [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp > $max} {
               set max $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $max
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_max_in_collection_from_name { col attribute name } {
   set i 0
   set max 0
   foreach_in_collection path $col {
      if {[get_node_info -name [get_path_info $path -from]] == $name} {
         if {$i == 0} {
            set max [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp > $max} {
               set max $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $max
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection_to_name2 { col attribute name } {
   set i 0
   set min 0
   foreach_in_collection path $col {
      if {[regexp $name [get_node_info -name [get_path_info $path -to]]]} {
         if {$i == 0} {
            set min [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp < $min} {
               set min $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_min_in_collection_from_name2 { col attribute name } {
   set i 0
   set min 0
   foreach_in_collection path $col {
      if {[regexp $name [get_node_info -name [get_path_info $path -from]]]} {
         if {$i == 0} {
            set min [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp < $min} {
               set min $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $min
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_max_in_collection_to_name2 { col attribute name } {
   set i 0
   set max 0
   foreach_in_collection path $col {
      if {[regexp $name [get_node_info -name [get_path_info $path -to]]]} {
         if {$i == 0} {
            set max [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp > $max} {
               set max $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $max
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_max_in_collection_from_name2 { col attribute name } {
   set i 0
   set max 0
   foreach_in_collection path $col {
      if {[regexp $name [get_node_info -name [get_path_info $path -from]]]} {
         if {$i == 0} {
            set max [get_path_info $path -${attribute}]
         } else {
            set temp [get_path_info $path -${attribute}]
            if {$temp > $max} {
               set max $temp
            } 
         }
         set i [expr $i + 1]
      }
   }
   return $max
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_sort_proc {a b} {
   set idxs [list 1 2 0]
   foreach i $idxs {
      set ai [lindex $a $i]
      set bi [lindex $b $i]
      if {$ai > $bi} {
         return 1
      } elseif { $ai < $bi } {
         return -1
      }
   }
   return 0
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_gcd {p q} {
   set p [expr {abs($p)}]
   set q [expr {abs($q)}]
   while {$q != 0} {
      set r [expr {$p % $q}]
      set p $q
      set q $r
   }
   return $p
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_atom_path {atom_id atom_oport_id path} {
   # Return list of {atom oterm_id} pairs by tracing the atom netlist starting from the given atom_id through the given path
   # Path consists of list of {atom_type fanin|fanout|end <port_type> <-optional>}
   set result [list]
   if {[llength $path] > 0} {
      set path_point [lindex $path 0]
      set atom_type [lindex $path_point 0]
      set next_direction [lindex $path_point 1]
      set port_type [lindex $path_point 2]
      set atom_optional [lindex $path_point 3]
      if {[get_atom_node_info -key type -node $atom_id] == $atom_type} {
         if {$next_direction == "end"} {
            if {[get_atom_port_info -key type -node $atom_id -port_id $atom_oport_id -type oport] == $port_type} {
               lappend result [list $atom_id $atom_oport_id]
            }
         } elseif {$next_direction == "atom"} {
            lappend result [list $atom_id]
         } elseif {$next_direction == "fanin"} {
            set atom_iport [get_atom_iport_by_type -node $atom_id -type $port_type]
            if {$atom_iport != -1} {
               set iport_fanin [get_atom_port_info -key fanin -node $atom_id -port_id $atom_iport -type iport]
               set source_atom [lindex $iport_fanin 0]
               set source_oterm [lindex $iport_fanin 1]
               set result [ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_atom_path $source_atom $source_oterm [lrange $path 1 end]]
            } elseif {$atom_optional == "-optional"} {
               set result [ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_atom_path $atom_id $atom_oport_id [lrange $path 1 end]]
            }
         } elseif {$next_direction == "fanout"} {
            set atom_oport [get_atom_oport_by_type -node $atom_id -type $port_type]
            if {$atom_oport != -1} {
               set oport_fanout [get_atom_port_info -key fanout -node $atom_id -port_id $atom_oport -type oport]
               foreach dest $oport_fanout {
                  set dest_atom [lindex $dest 0]
                  set dest_iterm [lindex $dest 1]
                  set fanout_result_list [ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_atom_path $dest_atom -1 [lrange $path 1 end]]
                  foreach fanout_result $fanout_result_list {
                     if {[lsearch $result $fanout_result] == -1} {
                        lappend result $fanout_result
                     }
                  }
               }
            }
         } else {
            error "Unexpected path"
         }
      } elseif {$atom_optional == "-optional"} {
         set result [ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_atom_path $atom_id $atom_oport_id [lrange $path 1 end]]
      }
   }
   return $result
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_operating_conditions_number {} {
   set cur_operating_condition [get_operating_conditions]
   set counter 0
   foreach_in_collection op [get_available_operating_conditions] {
      if {[string compare $cur_operating_condition $op] == 0} {
         return $counter
      }
      incr counter
   }
   return $counter
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_calculate_counter_value { cnt_hi cnt_lo cnt_bypass } {
   if {$cnt_bypass} {
      set result 1
   } else {
      set result [expr {$cnt_hi + $cnt_lo}]
   }
   return $result
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_ddr_pins { instname allpins var_array_name} {
   # We need to make a local copy of the allpins associative array
   upvar allpins pins
   upvar 1 $var_array_name var
   set debug 0

   # with the hyper-retimer, the tdb netlist may contain the full set of routing nodes, so we need
   # to search deeper
   if {[expr [get_global_assignment -name "HYPER_RETIMER"] == "ON"]} {
      set var(pll_inclock_search_depth) 250
      set var(pll_outclock_search_depth) 250
      set var(pll_vcoclock_search_depth) 50
   } else {
      set var(pll_inclock_search_depth) 25
      set var(pll_outclock_search_depth) 20
      set var(pll_vcoclock_search_depth) 5
   }

   # ########################################
   #  1.0 find all of the PLL output clocks

   #  C0 output in the periphery
   set pins(pll_c0_periph_clock) [list]
   set pins(pll_c0_periph_clock_id) [get_nets -nowarn [list ${instname}|arch|arch_inst|pll_inst|pll_lvds_clk\[0\]  ${instname}|arch|arch_inst|pll_inst|pll_inst*LVDS_CLK0]]
   foreach_in_collection c $pins(pll_c0_periph_clock_id) {
      lappend pins(pll_c0_periph_clock) [regsub {\\} [get_node_info -name $c] {\\\\}]
   }
   set pins(pll_c0_periph_clock) [join [lsort -decreasing $pins(pll_c0_periph_clock)]]

   #  C1 output in the periphery
   set pins(pll_c1_periph_clock) [list]
   set pins(pll_c1_periph_clock_id) [get_nets -nowarn [list ${instname}|arch|arch_inst|pll_inst|pll_loaden\[0\]  ${instname}|arch|arch_inst|pll_inst|pll_inst*LOADEN0]]
   foreach_in_collection c $pins(pll_c1_periph_clock_id) {
      lappend pins(pll_c1_periph_clock) [regsub {\\} [get_node_info -name $c] {\\\\}]
   }
   set pins(pll_c1_periph_clock) [join [lsort -decreasing $pins(pll_c1_periph_clock)]]

   #  VCO clock (used for the system clock)
   set pins(vco_clock) [list]
   set pins(vco_clock_id) [get_nets -nowarn [list ${instname}|arch|arch_inst|pll_inst|pll_vcoph\[0\]  ${instname}|arch|arch_inst|pll_inst|pll_inst*VCOPH0]]
   foreach_in_collection c $pins(vco_clock_id) {
      lappend pins(vco_clock) [regsub {\\} [get_node_info -name $c] {\\\\}]
   }
   set pins(vco_clock) [join [lsort -decreasing $pins(vco_clock)]]
   set pins(pll_vco_clock) $pins(vco_clock)
   set pins(pll_phy_clock) $pins(pll_c1_periph_clock)
   set pins(pll_phy_clock_l) $pins(pll_c0_periph_clock)

   if {$debug == 1} {
     puts "VCO:           $pins(pll_vco_clock)"
     puts "PHY:           $pins(pll_phy_clock)"   
     puts "PHY_L:         $pins(pll_phy_clock_l)"   
     puts ""
   }

   #########################################
   # 2.0  Find the actual master core clock 
   #      As it could come from another interface
   #      In master/slave configurations
   #
   # Skip this if we're in HPS mode as core clocks don't exist
   
   if {$var(IS_HPS)} {
      set pins(master_instname) $instname
      set pins(master_vco_clock) ""
      set pins(master_vco_clock_id) -1
      set pins(master_core_usr_clock) ""
      set pins(master_core_usr_2x_clock) ""
      set pins(master_core_usr_half_clock) ""
      set pins(master_core_afi_half_clock) ""
      set pins(master_core_afi_clock) ""
      set pins(master_core_dft_cpa_1_clock) ""
      set pins(uses_cpa) 1      
      if {$var(PHY_USERMODE_OCT)} {
         set pins(usermode_oct_clock) "${instname}|arch|arch_inst|oct_inst|cal_oct.manual_oct_cal.r_clkdiv"
         set pins(usermode_oct_gated_clock) "${instname}|arch|arch_inst|oct_inst|cal_oct.manual_oct_cal.oct_inst|altera_oct_um_fsm_i|clkena|outclk"
      } else {
         set pins(usermode_oct_clock) ""
         set pins(usermode_oct_gated_clock) ""
      }
      
   } else {
      
      set pins(usr_reg) ${instname}|arch|arch_inst|non_hps.core_clks_rsts_inst|sync_reset_n
      
      set core_reset_sync_clock "_UNDEFINED_PIN_"

      set msg_list [ list ]

      set core_reset_sync_clock_id [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_output_clock_id $pins(usr_reg) "Usr clock" msg_list var] 
      if {$core_reset_sync_clock_id == -1} {
         foreach {msg_type msg} $msg_list {
            post_message -type $msg_type "ed_synth_altera_emif_arch_nf_150_3u2ihai_pin_map.tcl: $msg"
         }
         post_message -type error "ed_synth_altera_emif_arch_nf_150_3u2ihai_pin_map.tcl: Failed to find PLL clock for pins [join $pins(usr_reg)].  Please verify the connectivity of these pins."
      } else {
         set core_reset_sync_clock [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_pll_clock_name $core_reset_sync_clock_id]
      }

      if {[regexp {(^.*)\|arch\|arch_inst\|io_tiles_inst\|tile_gen\[([0-9])\].tile_ctrl_inst(.*)\|pa_core_clk_out\[[0-9]\]$} $core_reset_sync_clock matched pins(master_instname) tilegen_num pins(master_instnum)] == 1} {
         if {$var(PHY_CONFIG_ENUM) == "CONFIG_PHY_AND_HARD_CTRL"} {

            if {$var(USER_CLK_RATIO) == 8} {
               set pins(master_core_usr_clock)      "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[0\]"
               set pins(master_core_usr_2x_clock)   "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[1\]"
               set pins(master_core_usr_half_clock) ""
            } elseif {$var(USER_CLK_RATIO) == 2 && $var(C2P_P2C_CLK_RATIO) == 4} {
               set pins(master_core_usr_clock)      "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[0\]"
               set pins(master_core_usr_half_clock) "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[1\]"
               set pins(master_core_usr_2x_clock)   ""
            } else {
               set pins(master_core_usr_clock)      "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[0\]"
               set pins(master_core_usr_half_clock) ""
               set pins(master_core_usr_2x_clock)   ""
            }
            
            set pins(master_core_afi_half_clock)                                     ""
            set pins(master_core_afi_clock)                                          ""
            set pins(master_core_dft_cpa_1_clock)   [expr {$var(DIAG_CPA_OUT_1_EN) ? "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[1\]" : ""}]
            
         } else {
            set pins(master_core_usr_clock)         ""
            set pins(master_core_usr_2x_clock)      ""
            set pins(master_core_usr_half_clock)    ""
            set pins(master_core_afi_half_clock)    "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[0\]"
            set pins(master_core_afi_clock)         "$pins(master_instname)|arch|arch_inst|io_tiles_inst|tile_gen\[${tilegen_num}\].tile_ctrl_inst${pins(master_instnum)}|pa_core_clk_out\[1\]"
            set pins(master_core_dft_cpa_1_clock)   ""
         }
      
         set pins(master_vco_clock) [list]
         set pins(master_vco_clock_id) [get_nets $pins(master_instname)|arch|arch_inst|pll_inst${pins(master_instnum)}|pll_vcoph\[0\]]
         foreach_in_collection c $pins(master_vco_clock_id) {
            lappend pins(master_vco_clock) [get_node_info -name $c]
         }
         set pins(master_vco_clock) [join [lsort $pins(master_vco_clock)]]
         set pins(uses_cpa) 1
         
      } else {
         post_message -type error "ed_synth_altera_emif_arch_nf_150_3u2ihai_pin_map.tcl: Failed to find CPA outputs."
      }
      
      if {!$var(DIAG_USE_CPA_LOCK)} {
         set pins(counter_lock_reg) $pins(master_instname)|arch|arch_inst|non_hps.core_clks_rsts_inst|counter_lock
      }

      if {$var(PHY_USERMODE_OCT)} {
         set pins(usermode_oct_clock) "${instname}|arch|arch_inst|oct_inst|cal_oct.manual_oct_cal.r_clkdiv"
         set pins(usermode_oct_gated_clock) "${instname}|arch|arch_inst|oct_inst|cal_oct.manual_oct_cal.oct_inst|altera_oct_um_fsm_i|clkena|outclk"
      } else {
         set pins(usermode_oct_clock) ""
         set pins(usermode_oct_gated_clock) ""
      }
   }

   if {$debug == 1} {
     puts "Master VCO           : $pins(master_vco_clock)"
     puts "Master Core USR      : $pins(master_core_usr_clock)"
     puts "Master Core USR 2X   : $pins(master_core_usr_2x_clock)"
     puts "Master Core USR Half : $pins(master_core_usr_half_clock)"
     puts "Master Core AFI      : $pins(master_core_afi_clock)"
     puts "Master Core AFI Half : $pins(master_core_afi_half_clock)"
     puts ""
   }
   

   # ########################################
   #  2.5 Find the reference clock input of the PLL

   set pins(pll_cascade_in_id) [get_pins -compatibility_mode $pins(master_instname)|arch|arch_inst|pll_inst|pll_inst|pll_cascade_in]
   set pll_ref_clock_id [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_input_clk_id $pins(pll_cascade_in_id) var] 
   if {$pll_ref_clock_id == -1} {
      post_message -type critical_warning "ed_synth_altera_emif_arch_nf_150_3u2ihai_pin_map.tcl: Failed to find PLL reference clock"
   } else {
      set pll_ref_clock [get_node_info -name $pll_ref_clock_id]
   }
   set pins(pll_ref_clock) $pll_ref_clock

   if {$debug == 1} {
     puts "REF:     $pins(pll_ref_clock)"
     puts ""
   }   

   #########################################
   # 3.0  find the FPGA pins

   # The hierarchy paths to all the pins are stored in the *_ip_parameters.tcl
   # file which is a generated file. Pins are divided into the following
   # protocol-agnostic categories. For each pin category, we need to
   # fully-resolve the hierarchy path patterns and store the results into
   # the "pins" arrays.
   set pin_categories [list ac_clk \
                            ac_clk_n \
                            ac_sync \
                            ac_async \
                            rclk \
                            rclk_n \
                            wclk \
                            wclk_n \
                            rdata \
                            wdata \
                            dm \
                            dbi ]

   set patterns [ list ]
   foreach pin_category $pin_categories {
      set pins($pin_category) [list]

      foreach pattern $var(PATTERNS_[string toupper $pin_category]) {
         set pattern "${instname}|$pattern"
         lappend patterns $pin_category $pattern
      }
   }

   foreach {pin_type pattern} $patterns { 
      if {[string match "*|o" $pattern]} {
         set local_pins [ ed_synth_altera_emif_arch_nf_150_3u2ihai_get_names_in_collection [ get_fanouts $pattern ] ]
      } else {
         set local_pins [ ed_synth_altera_emif_arch_nf_150_3u2ihai_get_names_in_collection [ get_fanins $pattern ] ]
      }

      if {[llength $local_pins] == 0} {
         post_message -type critical_warning "Could not find pin of type $pin_type from pattern $pattern"
      } else {
         foreach pin [lsort -unique $local_pins] {
            lappend pins($pin_type) $pin
         }
      }
   }
	
   #########################################
   # 4.0  setup extra PLL clocks parameters

   # User can use remaining PLL clocks from EMIF GUI and this is to
   # setup the parameters for those clocks such as multiply_by 
   # and divide_by

   if {$var(PLL_NUM_OF_EXTRA_CLKS) > 0} {

      set pll_master_user_clock_base [string range $pins(master_vco_clock) 0 [string last "|" $pins(master_vco_clock)] ]pll_inst|outclk

      set var(pll_num_of_reserved_cnts) 5

      for {set i 0} {$i < $var(PLL_NUM_OF_EXTRA_CLKS)} {incr i} {
         set i_cnt_num [expr $i + $var(pll_num_of_reserved_cnts)]
         set var(pll_c${i_cnt_num}_cnt) [ed_synth_altera_emif_arch_nf_150_3u2ihai_calculate_counter_value $var(PLL_C_CNT_HIGH_${i_cnt_num}) $var(PLL_C_CNT_LOW_${i_cnt_num}) $var(PLL_C_CNT_BYPASS_EN_${i_cnt_num})]
         set pins(pll_extra_clk_${i}) "$pll_master_user_clock_base\[$i_cnt_num\]"
      }
   }	
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_initialize_ddr_db { ddr_db_par var_array_name} {
   upvar $ddr_db_par local_ddr_db
   upvar 1 $var_array_name var

   global ::GLOBAL_ed_synth_altera_emif_arch_nf_150_3u2ihai_corename
   global ::io_only_analysis

   post_sdc_message info "Initializing DDR database for CORE $::GLOBAL_ed_synth_altera_emif_arch_nf_150_3u2ihai_corename"
   set instance_list [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_core_instance_list $::GLOBAL_ed_synth_altera_emif_arch_nf_150_3u2ihai_corename]

   foreach instname $instance_list {

      if {$::io_only_analysis == 0}  {
         post_sdc_message info "Finding port-to-pin mapping for CORE: $::GLOBAL_ed_synth_altera_emif_arch_nf_150_3u2ihai_corename INSTANCE: $instname"
         ed_synth_altera_emif_arch_nf_150_3u2ihai_get_ddr_pins $instname allpins var
         ed_synth_altera_emif_arch_nf_150_3u2ihai_verify_ddr_pins allpins var
      }

      set local_ddr_db($instname) [ array get allpins ]
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_verify_ddr_pins { pins_par var_array_name} {

   upvar 1 $var_array_name var
   upvar $pins_par pins

   if { [ llength $pins(pll_phy_clock) ] != [ llength $pins(pll_vco_clock) ] } {
      post_message -type critical_warning "Found different amounts of the phy_clocks compared to the vco_clocks"
   }
   if {!$var(IS_HPS)} {
      if {$var(PHY_CONFIG_ENUM) == "CONFIG_PHY_AND_HARD_CTRL"} {
         if { [ llength $pins(master_core_usr_clock) ] != 1 } {
            post_message -type critical_warning "Found [ llength $pins(master_core_usr_clock) ] of master_core_usr_clock when there should be 1"
         }
      
         if {$var(USER_CLK_RATIO) == 8} {
            if { [ llength $pins(master_core_usr_2x_clock) ] != 1 } {
               post_message -type critical_warning "Found [ llength $pins(master_core_usr_2x_clock) ] of master_core_usr_2x_clock when there should be 1"
            }
            if { [ llength $pins(master_core_usr_half_clock) ] != 0 } {
               post_message -type critical_warning "Found [ llength $pins(master_core_usr_half_clock) ] of master_core_usr_half_clock when there should be 0"
            }
         } elseif {$var(USER_CLK_RATIO) == 2 && $var(C2P_P2C_CLK_RATIO) == 4} {
            if { [ llength $pins(master_core_usr_2x_clock) ] != 0 } {
               post_message -type critical_warning "Found [ llength $pins(master_core_usr_2x_clock) ] of master_core_usr_2x_clock when there should be 0"
            }
            if { [ llength $pins(master_core_usr_half_clock) ] != 1 } {
               post_message -type critical_warning "Found [ llength $pins(master_core_usr_half_clock) ] of master_core_usr_half_clock when there should be 1"
            }
         }
      } else {
         if { [ llength $pins(master_core_afi_clock) ] != 1 } {
            post_message -type critical_warning "Found [ llength $pins(master_core_afi_clock) ] of master_core_afi_clock when there should be 1"
         }
         if { [ llength $pins(master_core_afi_half_clock) ] != 1 } {
            post_message -type critical_warning "Found [ llength $pins(master_core_afi_half_clock) ] of master_core_afi_half_clock when there should be 1"
         }
      }
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_all_instances_dqs_pins { ddr_db_par } {
   upvar $ddr_db_par local_ddr_db

   set dqs_pins [ list ]
   set instnames [ array names local_ddr_db ]
   foreach instance $instnames {
      array set pins $local_ddr_db($instance)

      foreach { dqs_pin } $pins(dqs_pins) {
         lappend dqs_pins ${dqs_pin}_IN
         lappend dqs_pins ${dqs_pin}_OUT
      }
      foreach { dqsn_pin } $pins(dqsn_pins) {
         lappend dqs_pins ${dqsn_pin}_OUT
      }
      foreach { ck_pin } $pins(ck_pins) {
         lappend dqs_pins $ck_pin
      }
   }

   return $dqs_pins
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_input_clk_id { pll_inclk_id var_array_name} {
   upvar 1 $var_array_name var
	
   array set results_array [list]

   ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_fanin_up_to_depth $pll_inclk_id ed_synth_altera_emif_arch_nf_150_3u2ihai_is_node_type_pin clock results_array $var(pll_inclock_search_depth)
   if {[array size results_array] == 1} {
      set pin_id [lindex [array names results_array] 0]
      set result $pin_id
   } else {
      post_message -type critical_warning "Could not find PLL clock for [get_node_info -name $pll_inclk_id]"
      set result -1
   }

   return $result
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_output_clock_id { pin_list pin_type msg_list_name var_array_name} {
   upvar 1 $msg_list_name msg_list
   upvar 1 $var_array_name var
   set output_clock_id -1

   set output_id_list [list]
   set pin_collection [get_keepers -no_duplicates $pin_list]
   if {[get_collection_size $pin_collection] == [llength $pin_list]} {
      foreach_in_collection id $pin_collection {
         lappend output_id_list $id
      }
   } elseif {[get_collection_size $pin_collection] == 0} {
      lappend msg_list "warning" "Could not find any $pin_type pins"
   } else {
      lappend msg_list "warning" "Could not find all $pin_type pins"
   }
   ed_synth_altera_emif_arch_nf_150_3u2ihai_get_pll_clock $output_id_list $pin_type output_clock_id $var(pll_outclock_search_depth)
   return $output_clock_id
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_pll_clock { dest_id_list node_type clock_id_name search_depth} {
   if {$clock_id_name != ""} {
      upvar 1 $clock_id_name clock_id
   }
   set clock_id -1

   array set clk_array [list]
   foreach node_id $dest_id_list {
      ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_fanin_up_to_depth $node_id ed_synth_altera_emif_arch_nf_150_3u2ihai_is_node_type_pll_clk clock clk_array $search_depth
   }
   if {[array size clk_array] == 1} {
      set clock_id [lindex [array names clk_array] 0]
      set clk [get_node_info -name $clock_id]
   } elseif {[array size clk_array] > 1} {
      puts "Found more than 1 clock driving the $node_type"
      set clk ""
   } else {
      set clk ""
   }

   return $clk
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_vco_clk_id { wf_clock_id var_array_name} {
   upvar 1 $var_array_name var

   array set results_array [list]

   ed_synth_altera_emif_arch_nf_150_3u2ihai_traverse_fanin_up_to_depth $wf_clock_id ed_synth_altera_emif_arch_nf_150_3u2ihai_is_node_type_vco clock results_array $var(pll_vcoclock_search_depth)
   if {[array size results_array] == 1} {
      set pin_id [lindex [array names results_array] 0]
      set result $pin_id
   } else {
      post_message -type critical_warning "Could not find VCO clock for [get_node_info -name $wf_clock_id]"
      set result -1
   }

   return $result
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_is_node_type_pll_clk { node_id } {
   set cell_id [get_node_info -cell $node_id]

   if {$cell_id == ""} {
      set result 0
   } else {
      set atom_type [get_cell_info -atom_type $cell_id]
      if {$atom_type == "IOPLL"} {
         set node_name [get_node_info -name $node_id]

         if  {[regexp {pll_inst~.*OUTCLK[0-9]$} $node_name]} {
            set result 1
         } else {
            set result 0
         }
      } elseif {$atom_type == "TILE_CTRL"} {
         set node_name [get_node_info -name $node_id]

         if {[regexp {tile_ctrl_inst.*\|pa_core_clk_out\[[0-9]\]$} $node_name]} {
            set result 1
         } else {
            set result 0
         }
      } else {
         set result 0
      }
   }
   return $result
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_is_node_type_vco { node_id } {
   set cell_id [get_node_info -cell $node_id]

   if {$cell_id == ""} {
      set result 0
   } else {
      set atom_type [get_cell_info -atom_type $cell_id]
      if {$atom_type == "IOPLL"} {
         set node_name [get_node_info -name $node_id]

         if {[regexp {pll_inst.*\|.*vcoph\[0\]$} $node_name]} {
            set result 1
         } elseif {[regexp {pll_inst.*VCOPH0$} $node_name]} {
            set result 1
         } else {
            set result 0
         }
      } else {
         set result 0
      }
   }
   return $result
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_does_ref_clk_exist { ref_clk_name } {

   set ref_clock_found 0
   foreach_in_collection iclk [get_clocks -nowarn] {
      set clk_targets [get_clock_info -target $iclk]
      foreach_in_collection itgt $clk_targets {
         set node_name [get_node_info -name $itgt]
         if {[string compare $node_name $ref_clk_name] == 0} {
            set ref_clock_found 1
            break
         }
      }
      if {$ref_clock_found == 1} {
         break;
      }
   }

   return $ref_clock_found
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_p2c_c2p_clock_uncertainty { instname } {

   set success 1
   set error_message ""
   set clock_uncertainty 0
   set debug 0

   package require ::quartus::atoms

   catch {read_atom_netlist} read_atom_netlist_out
   set read_atom_netlist_error [regexp "ERROR" $read_atom_netlist_out]

   if {$read_atom_netlist_error == 0} {

      regsub -all {\|} $instname "|*:" instname

      # Find the IOPLLs
      if {$success == 1} {
         set pll_atoms [get_atom_nodes -matching *${instname}|*:arch|*:arch_inst|*:pll_inst|* -type IOPLL]
         set num_pll_inst [get_collection_size $pll_atoms]

         if {$num_pll_inst == 0} {
            set success 0
            post_message -type critical_warning "The auto-constraining script was not able to detect any PLLs in the < $instname > memory interface."
         }
      }

      # Get atom parameters
      if {$success == 1} {

         set mcnt_list [list]
         set bw_list   [list]
         set cp_setting_list [list]

         foreach_in_collection pll_atom $pll_atoms {

            # M-counter value
            if {[get_atom_node_info -node $pll_atom -key  BOOL_IOPLL_M_CNT_BYPASS_EN] == 1} {
               set mcnt 1
            } else {
               set mcnt [expr [get_atom_node_info -node $pll_atom -key INT_IOPLL_M_CNT_HI_DIV] + [get_atom_node_info -node $pll_atom -key INT_IOPLL_M_CNT_LO_DIV]]
            }
            lappend mcnt_list $mcnt

            # BW
            set bw [get_atom_node_info -node $pll_atom -key  ENUM_PLL_BANDWIDTH_SELECT]
            if {[string compare -nocase $bw "AUTO"] == 0} {
               set bw "LOW"
            }
            lappend bw_list $bw

            # CP current setting
            set cp_setting [get_atom_node_info -node $pll_atom -key ENUM_IOPLL_PLL_CP_CURRENT]
            lappend cp_setting_list $cp_setting
         }

         # Make sure all IOPLL parameters are the same
         for {set i [expr [llength $mcnt_list] - 1]} {$i > 0} {set i [expr $i - 1]} {
            if {[lindex $mcnt_list $i] != [lindex $mcnt_list [expr $i - 1]]} {
               set success 0
               post_message -type critical_warning "The auto-constraining script found multiple PLLs in the < $instname > memory interface with different parameters."
            }
         }
         for {set i [expr [llength $bw_list] - 1]} {$i > 0} {set i [expr $i - 1]} {
            set bw_a [lindex $bw_list $i]
            set bw_b [lindex $bw_list [expr $i - 1]]
            if {[string compare -nocase $bw_a $bw_b] != 0} {
               set success 0
               post_message -type critical_warning "The auto-constraining script found multiple PLLs in the < $instname > memory interface with different parameters."
            }
         }
         for {set i [expr [llength $cp_setting_list] - 1]} {$i > 0} {set i [expr $i - 1]} {
            set cp_a [lindex $cp_setting_list $i]
            set cp_b [lindex $cp_setting_list [expr $i - 1]]
            if {[string compare -nocase $cp_a $cp_b] != 0} {
               set success 0
               post_message -type critical_warning "The auto-constraining script found multiple PLLs in the < $instname > memory interface with different parameters."
            }
         }
      }

      # Calculate clock uncertainty
      if {$success == 1} {

         set mcnt [lindex $mcnt_list 0]
         set bw   [string toupper [lindex $bw_list 0]]
         set cp_setting [lindex $cp_setting_list 0]
         set cp_current [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_cp_current_from_setting $cp_setting]

         if {$debug} {
            puts "MCNT : $mcnt"
            puts "BW   : $bw"
            puts "CP   : $cp_setting ($cp_current)"
         }

         set HFR  [get_clock_uncertainty_data NOM NOM NOM PLL OFFSET${mcnt} HFR $bw]
         set LFD  [get_clock_uncertainty_data NOM NOM NOM PLL OFFSET${mcnt} LFD $bw]
         set SPE  [ed_synth_altera_emif_arch_nf_150_3u2ihai_get_spe_from_cp_current $cp_current]

         set clock_uncertainty_sqrt  [expr sqrt(($LFD/2)*($LFD/2) + ($LFD/2)*($LFD/2))]
         set clock_uncertainty [ed_synth_altera_emif_arch_nf_150_3u2ihai_round_3dp [expr ($clock_uncertainty_sqrt + $SPE)*1e9]]

         if {$debug} {
            puts "HFR  : $HFR"
            puts "LFD  : $LFD"
            puts "SPE  : $SPE"
            puts "TOTAL: $clock_uncertainty"
         }

      }

   } else {
      set success 0
      post_message -type critical_warning "The auto-constraining script was not able to read the netlist."
   }

   # Output warning in the case that clock uncertainty can't be determined
   if {$success == 0} {
      post_message -type critical_warning "Verify the following:"
      post_message -type critical_warning " The core < $instname > is instantiated within another component (wrapper)"
      post_message -type critical_warning " The core is not the top-level of the project"
      post_message -type critical_warning " The memory interface pins are exported to the top-level of the project"
   }

   return $clock_uncertainty
}


proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_cp_current_from_setting { cp_setting } {

   set cp_current 0

   if {[string compare -nocase $cp_setting "PLL_CP_SETTING8"] == 0} {
      set cp_current 10
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING10"] == 0} {
      set cp_current 20
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING12"] == 0} {
      set cp_current 40
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING14"] == 0} {
      set cp_current 15
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING15"] == 0} {
      set cp_current 30
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING21"] == 0} {
      set cp_current 25
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING28"] == 0} {
      set cp_current 35
   } elseif {[string compare -nocase $cp_setting "PLL_CP_SETTING35"] == 0} {
      set cp_current 45
   } else {
      set cp_current 0
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_spe_from_cp_current { cp_current } {

   set spe 147.0e-12

   if {$cp_current <= 15} {
      set spe 147.0e-12
   } elseif {$cp_current <= 20} {
      set spe 117.0e-12
   } elseif {$cp_current <= 25} {
      set spe 87.0e-12
   } elseif {$cp_current <= 30} {
      set spe 75.0e-12
   } elseif {$cp_current <= 35} {
      set spe 60.0e-12
   } elseif {$cp_current <= 40} {
      set spe 55.0e-12
   } elseif {$cp_current <= 45} {
      set spe 49.0e-12
   } else {
      set spe 49.0e-12
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_odv_reduction_factor {master_pll_location inst phyclk_name} {

   set odv_reduction_factor 0.0
   set debug 0

   set phy_clocks [get_clocks $phyclk_name]
   foreach_in_collection c $phy_clocks { set phy_clock_targets [get_clock_info -targets $c] }
   foreach_in_collection p $phy_clock_targets { set pll_cell [get_node_info -cell $p] }
   set pll_location [get_cell_info -location $pll_cell]

   if {[regexp {IOPLL_X([0-9]+)_Y([0-9]+)_N([0-9]+)$} $master_pll_location matched master_x master_y master_n] == 1} {
      if {[regexp {IOPLL_X([0-9]+)_Y([0-9]+)_N([0-9]+)$} $pll_location matched x y n] == 1} {

      if {$master_x == $x} {

         if {$master_y == $y} {
            set odv_reduction_factor 0.0
         } else {
            set y_distance [expr abs($master_y - $y)]
            set y_distance_tiles [expr $y_distance / 27]

            set odv_reduction_factor 0
            if {$odv_reduction_factor < 0} {
               set odv_reduction_factor 0.0
            }
         }

         if {$debug == 1} {
            puts "$master_pll_location $pll_location $y_distance $y_distance_tiles $odv_reduction_factor"
         }

      } else {
         set odv_reduction_factor 0.0
       } 
     } else {
        set odv_reduction_factor 0.0
     }
   } else {
      set odv_reduction_factor 0.0
   }

   return $odv_reduction_factor
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_periphery_clock_uncertainty { results_array_name var_array_name } {
   upvar 1 $results_array_name results
   upvar 1 $var_array_name var

   set speed_temp_grade [get_speedgrade_name]

   set c2p_setup  [ed_synth_altera_emif_arch_nf_150_3u2ihai_round_3dp [expr [get_clock_uncertainty_data 900MV $speed_temp_grade EMIF SETUP C2P]*1e9 + ($var(PHY_REF_CLK_JITTER_PS) - 10.0)/1000.0]]
   set c2p_hold   [ed_synth_altera_emif_arch_nf_150_3u2ihai_round_3dp [expr [get_clock_uncertainty_data 900MV $speed_temp_grade EMIF HOLD C2P]*1e9  + ($var(PHY_REF_CLK_JITTER_PS) - 10.0)/1000.0]]
   set p2c_setup  [ed_synth_altera_emif_arch_nf_150_3u2ihai_round_3dp [expr [get_clock_uncertainty_data 900MV $speed_temp_grade EMIF SETUP P2C]*1e9 + ($var(PHY_REF_CLK_JITTER_PS) - 10.0)/1000.0]]
   set p2c_hold   [ed_synth_altera_emif_arch_nf_150_3u2ihai_round_3dp [expr [get_clock_uncertainty_data 900MV $speed_temp_grade EMIF HOLD P2C]*1e9  + ($var(PHY_REF_CLK_JITTER_PS) - 10.0)/1000.0]]

   set results [list $c2p_setup $c2p_hold $p2c_setup $p2c_hold]
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_core_clock_uncertainty { results_array_name var_array_name } {
   upvar 1 $results_array_name results
   upvar 1 $var_array_name var

   set c2c_same_setup  0
   set c2c_same_hold   0
   set c2c_diff_setup  0
   set c2c_diff_hold   0

   set results [list $c2c_same_setup $c2c_same_hold $c2c_diff_setup $c2c_diff_hold]
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_core_overconstraints { results_array_name var_array_name } {
   upvar 1 $results_array_name results
   upvar 1 $var_array_name var

   set speed_temp_grade [get_speedgrade_name]

   if {[regexp I $speed_temp_grade] == 1} {
      set results [list $var(C2C_SAME_CLK_SETUP_OC_NS) [expr $var(C2C_SAME_CLK_HOLD_OC_NS) + 0.02] $var(C2C_DIFF_CLK_SETUP_OC_NS) [expr $var(C2C_DIFF_CLK_HOLD_OC_NS) + 0.02]]
   } else {
      set results [list $var(C2C_SAME_CLK_SETUP_OC_NS) $var(C2C_SAME_CLK_HOLD_OC_NS) $var(C2C_DIFF_CLK_SETUP_OC_NS) $var(C2C_DIFF_CLK_HOLD_OC_NS)]
   }
}

proc ed_synth_altera_emif_arch_nf_150_3u2ihai_get_periphery_overconstraints { results_st_array_name results_mt_array_name var_array_name } {
   upvar 1 $results_st_array_name results_st
   upvar 1 $results_mt_array_name results_mt
   upvar 1 $var_array_name var

   set c2p_p2c_frequency [expr $var(PHY_MEM_CLK_FREQ_MHZ)/$var(C2P_P2C_CLK_RATIO)]

   set results_st [list $var(C2P_SETUP_OC_NS) $var(C2P_HOLD_OC_NS) $var(P2C_SETUP_OC_NS) $var(P2C_HOLD_OC_NS)]

   if {$var(PHY_TARGET_IS_ES)} {
      set results_mt [list [expr $var(C2P_SETUP_OC_NS) + 0.030] [expr $var(C2P_HOLD_OC_NS) + 0.020] [expr $var(P2C_SETUP_OC_NS) + 0.030] [expr $var(P2C_HOLD_OC_NS) + 0.020]]
   } elseif {$var(PHY_TARGET_IS_ES2)} {
      set results_mt [list [expr $var(C2P_SETUP_OC_NS) + 0.000] [expr $var(C2P_HOLD_OC_NS) + 0.050] [expr $var(P2C_SETUP_OC_NS) + 0.000] [expr $var(P2C_HOLD_OC_NS) + 0.050]]
   } else {
      set results_mt [list [expr $var(C2P_SETUP_OC_NS) + 0.000] [expr $var(C2P_HOLD_OC_NS) + 0.000] [expr $var(P2C_SETUP_OC_NS) + 0.000] [expr $var(P2C_HOLD_OC_NS) + 0.000]]
   }

}
