`timescale 1 ps / 1 ps
module ed_iss (
		output wire  global_reset_n,
		input wire   local_cal_success,
		input wire   local_cal_fail,
		input wire   traffic_gen_pass,
		input wire   traffic_gen_fail,
		input wire   traffic_gen_timeout
	);

	altsource_probe #(
		.sld_auto_instance_index ("NO"),
		.sld_instance_index      (0),
		.instance_id             ("GRST"),
		.probe_width             (0),
		.source_width            (1),
		.source_initial_value    ("0"),
		.enable_metastability    ("NO")
	) grst_source (
		.source (global_reset_n)
	);

	altsource_probe #(
		.sld_auto_instance_index ("NO"),
		.sld_instance_index      (1),
		.instance_id             ("CALS"),
		.probe_width             (1),
		.source_width            (0),
		.source_initial_value    ("0"),
		.enable_metastability    ("NO")
	) cals_probe (
		.probe  (local_cal_success)
	);

	altsource_probe #(
		.sld_auto_instance_index ("NO"),
		.sld_instance_index      (2),
		.instance_id             ("CALF"),
		.probe_width             (1),
		.source_width            (0),
		.source_initial_value    ("0"),
		.enable_metastability    ("NO")
	) calf_probe (
		.probe  (local_cal_fail)
	);

	altsource_probe #(
		.sld_auto_instance_index ("NO"),
		.sld_instance_index      (3),
		.instance_id             ("TGP"),
		.probe_width             (1),
		.source_width            (0),
		.source_initial_value    ("0"),
		.enable_metastability    ("NO")
	) tgp_probe (
		.probe  (traffic_gen_pass)
	);

	altsource_probe #(
		.sld_auto_instance_index ("NO"),
		.sld_instance_index      (4),
		.instance_id             ("TGF"),
		.probe_width             (1),
		.source_width            (0),
		.source_initial_value    ("0"),
		.enable_metastability    ("NO")
	) tgf_probe (
		.probe  (traffic_gen_fail)
	);

	altsource_probe #(
		.sld_auto_instance_index ("NO"),
		.sld_instance_index      (5),
		.instance_id             ("TGT"),
		.probe_width             (1),
		.source_width            (0),
		.source_initial_value    ("0"),
		.enable_metastability    ("NO")
	) tgt_probe (
		.probe  (traffic_gen_timeout)
	);

endmodule
